From b6b02ae07051d8a57fad5cfa0d599ed2a228e4dc Mon Sep 17 00:00:00 2001
From: Ajin Cherian <itsajin@gmail.com>
Date: Mon, 7 Oct 2024 23:52:31 -0400
Subject: [PATCH v16 1/4] Add CONFLICT RESOLVERS into the syntax for CREATE and
 ALTER SUBSCRIPTION

This patch provides support for configuring subscriptions with conflict resolvers.

Syntax for CREATE SUBSCRIPTION:
CREATE SUBSCRIPTION <subname> CONNECTION <conninfo> PUBLICATION <pubname> CONFLICT RESOLVER
    (conflict_type1 = resolver1, conflict_type2 = resolver2, conflict_type3 = resolver3,...);

Syntax for ALTER SUBSCRIPTION:
ALTER SUBSCRIPTION <subname> CONFLICT RESOLVER
    (conflict_type1 = resolver1, conflict_type2 = resolver2, conflict_type3 = resolver3,...);

Syntax for resetting conflict resolvers:
 ALTER SUBSCRIPTION <subname> RESET CONFLICT RESOLVER ALL

 ALTER SUBSCRIPTION <subname> RESET CONFLICT RESOLVER FOR conflict_type

Additionally, this patch includes documentation for conflict resolvers.
---
 doc/src/sgml/logical-replication.sgml         |  95 +---
 doc/src/sgml/monitoring.sgml                  |  13 +-
 doc/src/sgml/ref/alter_subscription.sgml      |  62 +++
 doc/src/sgml/ref/create_subscription.sgml     | 206 +++++++++
 src/backend/commands/subscriptioncmds.c       |  53 +++
 src/backend/parser/gram.y                     |  49 +-
 src/backend/replication/logical/conflict.c    | 426 +++++++++++++++++-
 src/bin/pg_dump/pg_dump.c                     | 116 ++++-
 src/bin/pg_dump/pg_dump.h                     |   8 +
 src/bin/psql/describe.c                       |  15 +-
 src/include/catalog/Makefile                  |   3 +-
 src/include/catalog/meson.build               |   1 +
 .../catalog/pg_subscription_conflict.h        |  55 +++
 src/include/nodes/parsenodes.h                |   7 +
 src/include/parser/kwlist.h                   |   1 +
 src/include/replication/conflict.h            |  49 +-
 src/test/regress/expected/oidjoins.out        |   1 +
 src/test/regress/expected/subscription.out    | 251 +++++++----
 src/test/regress/sql/subscription.sql         |  63 +++
 src/tools/pgindent/typedefs.list              |   3 +
 20 files changed, 1303 insertions(+), 174 deletions(-)
 create mode 100644 src/include/catalog/pg_subscription_conflict.h

diff --git a/doc/src/sgml/logical-replication.sgml b/doc/src/sgml/logical-replication.sgml
index 98a7ad0c27..86c9b0b671 100644
--- a/doc/src/sgml/logical-replication.sgml
+++ b/doc/src/sgml/logical-replication.sgml
@@ -1568,7 +1568,7 @@ test_sub=# SELECT * FROM t1 ORDER BY id;
  </sect1>
 
  <sect1 id="logical-replication-conflicts">
-  <title>Conflicts</title>
+  <title>Conflicts and Conflict Resolution</title>
 
   <para>
    Logical replication behaves similarly to normal DML operations in that
@@ -1582,86 +1582,19 @@ test_sub=# SELECT * FROM t1 ORDER BY id;
   </para>
 
   <para>
-   Additional logging is triggered, and the conflict statistics are collected (displayed in the
-   <link linkend="monitoring-pg-stat-subscription-stats"><structname>pg_stat_subscription_stats</structname></link> view)
-   in the following <firstterm>conflict</firstterm> cases:
-   <variablelist>
-    <varlistentry id="conflict-insert-exists" xreflabel="insert_exists">
-     <term><literal>insert_exists</literal></term>
-     <listitem>
-      <para>
-       Inserting a row that violates a <literal>NOT DEFERRABLE</literal>
-       unique constraint. Note that to log the origin and commit
-       timestamp details of the conflicting key,
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       should be enabled on the subscriber. In this case, an error will be
-       raised until the conflict is resolved manually.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-update-origin-differs" xreflabel="update_origin_differs">
-     <term><literal>update_origin_differs</literal></term>
-     <listitem>
-      <para>
-       Updating a row that was previously modified by another origin.
-       Note that this conflict can only be detected when
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       is enabled on the subscriber. Currently, the update is always applied
-       regardless of the origin of the local row.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-update-exists" xreflabel="update_exists">
-     <term><literal>update_exists</literal></term>
-     <listitem>
-      <para>
-       The updated value of a row violates a <literal>NOT DEFERRABLE</literal>
-       unique constraint. Note that to log the origin and commit
-       timestamp details of the conflicting key,
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       should be enabled on the subscriber. In this case, an error will be
-       raised until the conflict is resolved manually. Note that when updating a
-       partitioned table, if the updated row value satisfies another partition
-       constraint resulting in the row being inserted into a new partition, the
-       <literal>insert_exists</literal> conflict may arise if the new row
-       violates a <literal>NOT DEFERRABLE</literal> unique constraint.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-update-missing" xreflabel="update_missing">
-     <term><literal>update_missing</literal></term>
-     <listitem>
-      <para>
-       The tuple to be updated was not found. The update will simply be
-       skipped in this scenario.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-delete-origin-differs" xreflabel="delete_origin_differs">
-     <term><literal>delete_origin_differs</literal></term>
-     <listitem>
-      <para>
-       Deleting a row that was previously modified by another origin. Note that
-       this conflict can only be detected when
-       <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
-       is enabled on the subscriber. Currently, the delete is always applied
-       regardless of the origin of the local row.
-      </para>
-     </listitem>
-    </varlistentry>
-    <varlistentry id="conflict-delete-missing" xreflabel="delete_missing">
-     <term><literal>delete_missing</literal></term>
-     <listitem>
-      <para>
-       The tuple to be deleted was not found. The delete will simply be
-       skipped in this scenario.
-      </para>
-     </listitem>
-    </varlistentry>
-   </variablelist>
-    Note that there are other conflict scenarios, such as exclusion constraint
-    violations. Currently, we do not provide additional details for them in the
-    log.
+   There are various conflict scenarios, each identified as a <firstterm>conflict type</firstterm>.
+   Users can configure a <firstterm>conflict resolver</firstterm> for each
+   conflict type when creating a subscription. For more information, refer to
+   <link linkend="sql-createsubscription-params-with-conflict-resolver">
+   <command>CREATE SUBSCRIPTION ... CONFLICT RESOLVER</command></link>.
+  </para>
+  <para>
+   When a conflict occurs the details about it are logged, and the conflict
+   statistics are recorded in the <link linkend="monitoring-pg-stat-subscription-stats">
+   <structname>pg_stat_subscription_stats</structname></link> view.
+   Note that there are other conflict scenarios, such as exclusion constraint
+   violations. Currently, we do not provide additional details for them in the
+   log.
   </para>
 
   <para>
diff --git a/doc/src/sgml/monitoring.sgml b/doc/src/sgml/monitoring.sgml
index 331315f8d3..d79db76e16 100644
--- a/doc/src/sgml/monitoring.sgml
+++ b/doc/src/sgml/monitoring.sgml
@@ -2181,7 +2181,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times a row insertion violated a
        <literal>NOT DEFERRABLE</literal> unique constraint during the
-       application of changes. See <xref linkend="conflict-insert-exists"/>
+       application of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-insert-exists"/>
        for details about this conflict.
       </para></entry>
      </row>
@@ -2193,7 +2193,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times an update was applied to a row that had been previously
        modified by another source during the application of changes. See
-       <xref linkend="conflict-update-origin-differs"/> for details about this
+       <xref linkend="sql-createsubscription-params-with-conflict_type-update-origin-differs"/> for details about this
        conflict.
       </para></entry>
      </row>
@@ -2205,7 +2205,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times that an updated row value violated a
        <literal>NOT DEFERRABLE</literal> unique constraint during the
-       application of changes. See <xref linkend="conflict-update-exists"/>
+       application of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-update-exists"/>
        for details about this conflict.
       </para></entry>
      </row>
@@ -2216,7 +2216,8 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       </para>
       <para>
        Number of times the tuple to be updated was not found during the
-       application of changes. See <xref linkend="conflict-update-missing"/>
+       application of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-update-missing
+"/>
        for details about this conflict.
       </para></entry>
      </row>
@@ -2228,7 +2229,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       <para>
        Number of times a delete operation was applied to row that had been
        previously modified by another source during the application of changes.
-       See <xref linkend="conflict-delete-origin-differs"/> for details about
+       See <xref linkend="sql-createsubscription-params-with-conflict_type-delete-origin-differs"/> for details about
        this conflict.
       </para></entry>
      </row>
@@ -2239,7 +2240,7 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       </para>
       <para>
        Number of times the tuple to be deleted was not found during the application
-       of changes. See <xref linkend="conflict-delete-missing"/> for details
+       of changes. See <xref linkend="sql-createsubscription-params-with-conflict_type-delete-missing"/> for details
        about this conflict.
       </para></entry>
      </row>
diff --git a/doc/src/sgml/ref/alter_subscription.sgml b/doc/src/sgml/ref/alter_subscription.sgml
index fdc648d007..e97edfecba 100644
--- a/doc/src/sgml/ref/alter_subscription.sgml
+++ b/doc/src/sgml/ref/alter_subscription.sgml
@@ -32,6 +32,9 @@ ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> SET ( <repl
 ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> SKIP ( <replaceable class="parameter">skip_option</replaceable> = <replaceable class="parameter">value</replaceable> )
 ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> OWNER TO { <replaceable>new_owner</replaceable> | CURRENT_ROLE | CURRENT_USER | SESSION_USER }
 ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> RENAME TO <replaceable>new_name</replaceable>
+ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> = <replaceable class="parameter">conflict_resolver</replaceable> [, ...] )
+ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> RESET CONFLICT RESOLVER ALL
+ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> RESET CONFLICT RESOLVER FOR '<replaceable class="parameter">conflict_type</replaceable>'
 </synopsis>
  </refsynopsisdiv>
 
@@ -345,6 +348,65 @@ ALTER SUBSCRIPTION <replaceable class="parameter">name</replaceable> RENAME TO <
      </para>
     </listitem>
    </varlistentry>
+
+   <varlistentry id="sql-altersubscription-params-conflict-resolver">
+    <term><literal>CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> = <replaceable class="parameter">conflict_resolver</replaceable> [, ... ] )</literal></term>
+    <listitem>
+     <para>
+      This clause alters the current conflict resolver for the specified conflict types.
+      Refer to <link linkend="sql-createsubscription-params-with-conflict-resolver">
+      <command>CREATE SUBSCRIBER ... CONFLICT RESOLVER</command></link>
+      for details about different <literal>conflict_type</literal> and what
+      kind of <literal>conflict_resolver</literal> can be assigned to them.
+     </para>
+     <variablelist>
+      <varlistentry id="sql-altersubscription-params-conflict-resolver-type">
+       <term><replaceable class="parameter">conflict_type</replaceable></term>
+       <listitem>
+        <para>
+         The conflict type.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry id="sql-altersubscription-params-conflict-resolver-resolver">
+       <term><replaceable class="parameter">conflict_resolver</replaceable></term>
+       <listitem>
+        <para>
+         The conflict resolver to use for this conflict type.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+    </listitem>
+   </varlistentry>
+
+   <varlistentry id="sql-altersubscription-params-reset-conflict-resolver">
+    <term><literal>RESET CONFLICT RESOLVER</literal></term>
+    <listitem>
+     <para>
+     Conflict types can either be reset to their default resolvers all at once using <replaceable class="parameter">ALL</replaceable>, or a specific conflict type can be reset using <replaceable class="parameter">FOR 'conflict_type'</replaceable>.
+     For details on conflict types and their default resolvers, refer to section <link linkend="sql-createsubscription-params-with-conflict-resolver"><literal>CREATE SUBSCRIBER ... CONFLICT RESOLVER</literal></link>.
+     </para>
+     <variablelist>
+      <varlistentry id="sql-altersubscription-params-reset-all">
+       <term><literal>ALL</literal></term>
+       <listitem>
+        <para>
+         All conflict types will be reset to their respective default resolvers.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry id="sql-altersubscription-params-reset-conflict-type">
+       <term><literal>FOR</literal> <replaceable class="parameter">conflict_type</replaceable></term>
+       <listitem>
+        <para>
+         The given <replaceable class="parameter">conflict_type</replaceable> will be reset to its default resolver.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+    </listitem>
+   </varlistentry>
   </variablelist>
 
   <para>
diff --git a/doc/src/sgml/ref/create_subscription.sgml b/doc/src/sgml/ref/create_subscription.sgml
index 8a3096e62b..91d5ffbab4 100644
--- a/doc/src/sgml/ref/create_subscription.sgml
+++ b/doc/src/sgml/ref/create_subscription.sgml
@@ -24,6 +24,7 @@ PostgreSQL documentation
 CREATE SUBSCRIPTION <replaceable class="parameter">subscription_name</replaceable>
     CONNECTION '<replaceable class="parameter">conninfo</replaceable>'
     PUBLICATION <replaceable class="parameter">publication_name</replaceable> [, ...]
+    [ CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> = <replaceable class="parameter">conflict_resolver</replaceable> [, ...] ) ]
     [ WITH ( <replaceable class="parameter">subscription_parameter</replaceable> [= <replaceable class="parameter">value</replaceable>] [, ... ] ) ]
 </synopsis>
  </refsynopsisdiv>
@@ -97,6 +98,211 @@ CREATE SUBSCRIPTION <replaceable class="parameter">subscription_name</replaceabl
     </listitem>
    </varlistentry>
 
+   <varlistentry id="sql-createsubscription-params-with-conflict-resolver">
+    <term><literal>CONFLICT RESOLVER ( <replaceable class="parameter">conflict_type</replaceable> = <replaceable class="parameter">conflict_resolver</replaceable> [, ... ] )</literal></term>
+    <listitem>
+     <para>
+      This optional clause specifies conflict resolvers for different conflict_types.
+     </para>
+
+     <para>
+      The default behavior for each <replaceable class="parameter">conflict_type</replaceable> is listed below.
+      <variablelist>
+       <varlistentry id="sql-createsubscription-params-with-conflict_type-insert-exists" xreflabel="insert_exists">
+        <term><literal>insert_exists</literal> (<type>enum</type>)</term>
+        <listitem>
+         <para>
+          This conflict occurs when inserting a row that violates a
+          <literal>NOT DEFERRABLE</literal> unique constraint.
+          To log the origin and commit timestamp details of the conflicting key,
+          <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+          should be enabled on the subscriber. In this case, an error will be
+          raised until the conflict is resolved manually or the resolver is configured to a
+          non-default value that can automatically resolve the conflict.
+         </para>
+        </listitem>
+       </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_type-update-exists" xreflabel="update_exists">
+       <term><literal>update_exists</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This conflict occurs when the updated value of a row violates
+         a <literal>NOT DEFERRABLE</literal>
+         unique constraint. To log the origin and commit
+         timestamp details of the conflicting key,
+         <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+         should be enabled on the subscriber. In this case, an error will be
+         raised until the conflict is resolved manually or the resolver is configured to a
+         non-default value that can automatically resolve the conflict.
+         Note that when updating a partitioned table, if the updated row
+         value satisfies another partition constraint resulting in the
+         row being inserted into a new partition, the <literal>insert_exists</literal>
+         conflict may arise if the new row violates a <literal>NOT DEFERRABLE</literal>
+         unique constraint.
+        </para>
+        <warning>
+         <para>
+          If the local table contains multiple <literal>NOT DEFERRABLE</literal> unique constraint
+          columns and the conflict resolution strategy for an INSERT or UPDATE favors applying the changes,
+          then a remote INSERT or UPDATE could trigger multiple <literal>update_exists</literal> conflicts.
+          Each conflict will be detected and resolved in sequence, potentially leading to the deletion of
+          multiple local rows.
+         </para>
+        </warning>
+       </listitem>
+      </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_type-update-missing" xreflabel="update_missing">
+       <term><literal>update_missing</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This conflict occurs when the tuple to be updated was not found.
+         The update will simply be skipped in this scenario.
+        </para>
+       </listitem>
+      </varlistentry>
+
+       <varlistentry id="sql-createsubscription-params-with-conflict_type-update-origin-differs" xreflabel="update_origin_differs">
+        <term><literal>update_origin_differs</literal> (<type>enum</type>)</term>
+        <listitem>
+         <para>
+          This conflict occurs when updating a row that was previously
+          modified by another origin.
+          Note that this conflict can only be detected when
+          <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+          is enabled on the subscriber. Currently, the update is always applied
+          regardless of the origin of the local row.
+         </para>
+        </listitem>
+      </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_type-delete-missing" xreflabel="delete_missing">
+       <term><literal>delete_missing</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This conflict occurs when the tuple to be deleted was not found.
+         The delete will simply be skipped in this scenario.
+        </para>
+       </listitem>
+      </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_type-delete-origin-differs" xreflabel="delete_origin_differs">
+       <term><literal>delete_origin_differs</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This conflict occurs when deleting a row that was previously modified
+         by another origin. Note that this conflict can only be detected when
+         <link linkend="guc-track-commit-timestamp"><varname>track_commit_timestamp</varname></link>
+         is enabled on the subscriber. Currently, the delete is always applied
+         regardless of the origin of the local row.
+        </para>
+       </listitem>
+      </varlistentry>
+
+     </variablelist>
+    </para>
+
+    <para>
+     The behavior of each <replaceable class="parameter">conflict_resolver</replaceable>
+     is described below. Users can choose from the following resolvers for automatic conflict
+     resolution.
+     <variablelist>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_resolver-error">
+       <term><literal>error</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This resolver throws an error and stops replication. It can be used for
+         any conflict type.
+         It is the default resolver for <literal>insert_exists</literal> and
+         <literal>update_exists</literal>.
+        </para>
+       </listitem>
+      </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_resolver-skip">
+       <term><literal>skip</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This resolver skips processing the remote change and continue replication
+         with the next change.
+         It can be used for <literal>update_missing</literal> and
+         <literal>delete_missing</literal> and is the default resolver for these types.
+        </para>
+       </listitem>
+      </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_resolver-apply-remote">
+       <term><literal>apply_remote</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This resolver applies the remote change. It can be used for
+         <literal>insert_exists</literal>, <literal>update_exists</literal>,
+         <literal>update_origin_differs</literal> and <literal>delete_origin_differs</literal>.
+         It is the default resolver for <literal>update_origin_differs</literal> and
+         <literal>delete_origin_differs</literal>.
+        </para>
+       </listitem>
+      </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_resolver-keep-local">
+       <term><literal>keep_local</literal> (<type>enum</type>)</term>
+        <listitem>
+         <para>
+          With this resolver, the remote change is not applied and the local tuple is maintained.
+          It can be used for <literal>insert_exists</literal>, <literal>update_exists</literal>,
+          <literal>update_origin_differs</literal> and <literal>delete_origin_differs</literal>.
+         </para>
+        </listitem>
+       </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_resolver-apply-or-error">
+       <term><literal>apply_or_error</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This resolver is only used for <literal>update_missing</literal>.
+         An attempt is made to convert the update into an insert; if this cannot
+         be done due to missing information, then an error is thrown, and replication
+         is stopped.
+        </para>
+       </listitem>
+      </varlistentry>
+
+      <varlistentry id="sql-createsubscription-params-with-conflict_resolver-apply-or-skip">
+       <term><literal>apply_or_skip</literal> (<type>enum</type>)</term>
+       <listitem>
+        <para>
+         This resolver is only used for <literal>update_missing</literal>.
+         An attempt is made to convert the update into an insert; if this
+         cannot be done due to missing information, then the change is skipped.
+        </para>
+       </listitem>
+      </varlistentry>
+
+      </variablelist>
+     </para>
+
+     <table id="sql-createsubscription-params-conflict-type-resolver-summary">
+      <title>Conflict type/resolver Summary</title>
+      <tgroup cols="3">
+       <thead>
+        <row><entry>Conflict type</entry>        <entry>Default resolver</entry>  <entry>Possible resolvers</entry></row>
+       </thead>
+       <tbody>
+        <row><entry>insert_exists</entry>        <entry>error</entry>             <entry>apply_remote, error, keep_local</entry></row>
+        <row><entry>update_exists</entry>        <entry>error</entry>             <entry>apply_remote, error, keep_local</entry></row>
+        <row><entry>update_missing</entry>       <entry>skip</entry>              <entry>apply_or_error, apply_or_skip, error, skip</entry></row>
+        <row><entry>update_origin_differs</entry><entry>apply_remote</entry>      <entry>apply_remote, error, keep_local</entry></row>
+        <row><entry>delete_missing</entry>       <entry>skip</entry>              <entry>error, skip</entry></row>
+        <row><entry>delete_origin_differs</entry><entry>apply_remote</entry>      <entry>apply_remote, error, keep_local</entry></row>
+       </tbody>
+      </tgroup>
+     </table>
+
+    </listitem>
+   </varlistentry>
+
    <varlistentry id="sql-createsubscription-params-with">
     <term><literal>WITH ( <replaceable class="parameter">subscription_parameter</replaceable> [= <replaceable class="parameter">value</replaceable>] [, ... ] )</literal></term>
     <listitem>
diff --git a/src/backend/commands/subscriptioncmds.c b/src/backend/commands/subscriptioncmds.c
index 02ccc636b8..54d8ad9554 100644
--- a/src/backend/commands/subscriptioncmds.c
+++ b/src/backend/commands/subscriptioncmds.c
@@ -36,6 +36,7 @@
 #include "executor/executor.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
+#include "parser/scansup.h"
 #include "pgstat.h"
 #include "replication/logicallauncher.h"
 #include "replication/logicalworker.h"
@@ -583,6 +584,7 @@ CreateSubscription(ParseState *pstate, CreateSubscriptionStmt *stmt,
 	bits32		supported_opts;
 	SubOpts		opts = {0};
 	AclResult	aclresult;
+	List	   *conflict_resolvers = NIL;
 
 	/*
 	 * Parse and check options.
@@ -597,6 +599,10 @@ CreateSubscription(ParseState *pstate, CreateSubscriptionStmt *stmt,
 					  SUBOPT_RUN_AS_OWNER | SUBOPT_FAILOVER | SUBOPT_ORIGIN);
 	parse_subscription_options(pstate, stmt->options, supported_opts, &opts);
 
+	/* Parse and get conflict resolvers list. */
+	conflict_resolvers =
+		ParseAndGetSubConflictResolvers(pstate, stmt->resolvers, true);
+
 	/*
 	 * Since creating a replication slot is not transactional, rolling back
 	 * the transaction leaves the created replication slot.  So we cannot run
@@ -723,6 +729,9 @@ CreateSubscription(ParseState *pstate, CreateSubscriptionStmt *stmt,
 
 	recordDependencyOnOwner(SubscriptionRelationId, subid, owner);
 
+	/* Update the Conflict Resolvers in pg_subscription_conflict */
+	SetSubConflictResolvers(subid, conflict_resolvers);
+
 	ReplicationOriginNameForLogicalRep(subid, InvalidOid, originname, sizeof(originname));
 	replorigin_create(originname);
 
@@ -1581,6 +1590,47 @@ AlterSubscription(ParseState *pstate, AlterSubscriptionStmt *stmt,
 				update_tuple = true;
 				break;
 			}
+		case ALTER_SUBSCRIPTION_CONFLICT_RESOLVERS:
+			{
+				List	   *conflict_resolvers = NIL;
+
+				/*
+				 * Get the list of conflict types and resolvers and validate
+				 * them.
+				 */
+				conflict_resolvers = ParseAndGetSubConflictResolvers(
+																	 pstate,
+																	 stmt->resolvers,
+																	 false);
+
+				/*
+				 * Update the conflict resolvers for the corresponding
+				 * conflict types in the pg_subscription_conflict catalog.
+				 */
+				UpdateSubConflictResolvers(conflict_resolvers, subid);
+				break;
+			}
+		case ALTER_SUBSCRIPTION_CONFLICT_RESOLVER_RESET_ALL:
+			{
+				List	   *conflict_resolvers = NIL;
+
+				/*
+				 * Create list of conflict resolvers and set them in the
+				 * catalog.
+				 */
+				conflict_resolvers = GetDefaultConflictResolvers();
+				UpdateSubConflictResolvers(conflict_resolvers, subid);
+				break;
+			}
+		case ALTER_SUBSCRIPTION_CONFLICT_RESOLVER_RESET:
+			{
+				/*
+				 * Reset the conflict resolver for this conflict type to its
+				 * default.
+				 */
+				ResetSubConflictResolver(subid, stmt->conflict_type_name);
+				break;
+			}
 
 		default:
 			elog(ERROR, "unrecognized ALTER SUBSCRIPTION kind %d",
@@ -1832,6 +1882,9 @@ DropSubscription(DropSubscriptionStmt *stmt, bool isTopLevel)
 	/* Remove any associated relation synchronization states. */
 	RemoveSubscriptionRel(subid, InvalidOid);
 
+	/* Remove any associated conflict resolvers */
+	RemoveSubConflictResolvers(subid);
+
 	/* Remove the origin tracking if exists. */
 	ReplicationOriginNameForLogicalRep(subid, InvalidOid, originname, sizeof(originname));
 	replorigin_drop_by_name(originname, true, false);
